/*
	GLfunge98 IPstruct.h
	IP structure, in this header file for extensions
*/

#ifndef __GLFUNGE_IPSTRUCT_H
#define __GLFUNGE_IPSTRUCT_H

struct s_extsave {
	void * extlibhandle;
	struct s_extsave * prevext;
};

typedef struct s_IP {
	/* stack-related variables */
	long int * stack;
	unsigned long int stacksize;
	unsigned long int SP;
	/* IP delta and position */
	long int dx, dy;
	long int posx, posy;
	/* storage offset values */
	long int soffx, soffy;
	/* IP number in the IP list */
	unsigned long int num;
	/* stringmode on */
	int stringmode;
	/* extension handling */
	void * extfunctable[26];
	void * curlib;
	/* function addresses for extensions */
	long int (*getfunc)(long int, long int);
	void (*putfunc)(long int, long int, long int);
	long int (*popfunc)(struct s_IP *);
	void (*pushfunc)(struct s_IP *, long int);
	void (*outchrfunc)(long int);
	void (*outdecfunc)(long int);
	long int (*inpchrfunc)(void);
	long int (*inpdecfunc)(void);
	struct s_extsave * prevlib;
	unsigned long int * flags;
} IP;

#endif /* __GLFUNGE_IPSTRUCT_H */
