/*
	GLfunge98 'ROMA' extension (fingerprint 0x524f4d41)
	Implementation Copyright (C) 2000, Heikki Kallasjoki
	Semantics by Cat's eye Technologies'

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
*/


#include <stdlib.h>
#include <IPstruct.h>


/* actual functions */
void * oldfunks[7];
int push_C(IP * curIP) { (*curIP->pushfunc)(curIP, 100); return 1; }
int push_D(IP * curIP) { (*curIP->pushfunc)(curIP, 500); return 1; }
int push_I(IP * curIP) { (*curIP->pushfunc)(curIP, 1); return 1; }
int push_L(IP * curIP) { (*curIP->pushfunc)(curIP, 50); return 1; }
int push_M(IP * curIP) { (*curIP->pushfunc)(curIP, 1000); return 1; }
int push_V(IP * curIP) { (*curIP->pushfunc)(curIP, 5); return 1; }
int push_X(IP * curIP) { (*curIP->pushfunc)(curIP, 10); return 1; }

/* necessary functions for GLfunge98-extension */

/* registercmd - registers a command function to a funge-command */
void * registercmd(void * oldfunc, int cmdchar, int * statusval) {
	*statusval = 1;

	switch(cmdchar) {
	case 'C':
		oldfunks[0] = oldfunc;
		return push_C;
	case 'D':
		oldfunks[1] = oldfunc;
		return push_D;
	case 'I':
		oldfunks[2] = oldfunc;
		return push_I;
	case 'L':
		oldfunks[3] = oldfunc;
		return push_L;
	case 'M':
		oldfunks[4] = oldfunc;
		return push_M;
	case 'V':
		oldfunks[5] = oldfunc;
		return push_V;
	case 'X':
		oldfunks[6] = oldfunc;
		return push_X;
	}

	*statusval = 0;
	return NULL;
}

/* restorecmd - restores old commands */
void * restorecmd(int cmdchar, int * statusval) {
	*statusval = 1;

	switch(cmdchar) {
	case 'C':
		return oldfunks[0];
	case 'D':
		return oldfunks[1];
	case 'I':
		return oldfunks[2];
	case 'L':
		return oldfunks[3];
	case 'M':
		return oldfunks[4];
	case 'V':
		return oldfunks[5];
	case 'X':
		return oldfunks[6];
	}

	*statusval = 0;
	return NULL;
}


