/*
	GLfunge98 'SCKE' extension, fingerprint 0x53434b45
	Copyright (C) 2000, Heikki Kallasjoki
	Additions by Heikki Kallasjoki, in SCKE-extension

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
*/


#include <stdlib.h>
#include <IPstruct.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <arpa/inet.h>


/* global variables */
/*void * prevlib;*/


/* actual functions */
void * oldfunks[2];

int cmd_H(IP * curIP) { /* "Get address by hostname" */
	char * str1, * str2;
	int lens, pos; long int mychr;
	struct in_addr myaddr;
	struct hostent * myhost;

	lens = 256;
	str1 = (char *)malloc(lens);
	if(!str1) { curIP->dx = -curIP->dx; curIP->dy = -curIP->dy; return 1; }

	pos = 0;
	while((mychr = (*curIP->popfunc)(curIP)) != 0) {
		str1[pos++] = mychr & 0xFF;
		if(pos == lens) {
			lens += 256;
			str2 = (char *)malloc(lens);
			if(!str2) { free(str1); curIP->dx = -curIP->dx; curIP->dy = -curIP->dy; return 1; }
			memcpy(str2, str1, lens - 256);
			free(str1);
			str1 = str2;
		}
	}
	str1[pos] = '\0';

	if(inet_aton(str1, &myaddr)) {
		(*curIP->pushfunc)(curIP, ntohl(myaddr.s_addr));
		return 1;
	}
	
	myhost = gethostbyname(str1);
	if((!myhost) || (myhost->h_addrtype != AF_INET)) { free(str1); curIP->dx = -curIP->dx; curIP->dy = -curIP->dy; return 1; }

	(*curIP->pushfunc)(curIP, ntohl(*myhost->h_addr));
	
	return 1;
}
int cmd_P(IP * curIP) { /* "Peek for incoming data" */
	fd_set rfds; long int s; struct timeval tv; int i;

	s = (*curIP->popfunc)(curIP);
	
	FD_ZERO(&rfds);
	FD_SET(s, &rfds);
	tv.tv_sec = 0;
	tv.tv_usec = 0;
	
	i = select(s + 1, &rfds, NULL, NULL, &tv);
	if(i == -1) { curIP->dx = -curIP->dx; curIP->dy = -curIP->dy; return 1; }
	
	(*curIP->pushfunc)(curIP, i);
	return 1;
}

/* necessary functions for GLfunge98-extension */

int initext(void) {
	return 1;
}

int deinitext(void) {
	return 1;
}

/* saveprev, restoreprev - saves and restores previous library */
/*void saveprev(void * plib) { prevlib = plib; }
void * restoreprev(void) { return prevlib; }*/

/* registercmd - registers a command function to a funge-command */
void * registercmd(void * oldfunc, int cmdchar, int * statusval) {
	*statusval = 1;

	switch(cmdchar) {
	case 'H':
		oldfunks[0] = oldfunc;
		return cmd_H;
	case 'P':
		oldfunks[1] = oldfunc;
		return cmd_P;
	}

	*statusval = 0;
	return NULL;
}

/* restorecmd - restores old commands */
void * restorecmd(int cmdchar, int * statusval) {
	*statusval = 1;

	switch(cmdchar) {
	case 'H':
		return oldfunks[0];
	case 'P':
		return oldfunks[1];
	}

	*statusval = 0;
	return NULL;
}


